﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace DAL
{
    class DbHelperSQL
    {
        public static string connectionString = System.Configuration.ConfigurationManager.ConnectionStrings["ConnectionString"].ToString();
        public static int ExecuteSql(string SQLString, params SqlParameter[] cmdParms)
        {
            using (SqlConnection connection=new SqlConnection())
            {
                  using (SqlCommand cmd = new SqlCommand())
                  {
                      try
                      {
                          PrepareCommand(cmd, connection, null, SQLString, cmdParms);
                          int rows = cmd.ExecuteNonQuery();
                          cmd.Parameters.Clear();
                          return rows;
                      }
                      catch (System.Data.SqlClient.SqlException e)
                      {
                          throw e;
                      }
                  }

            }
          
        }
        public static object GetSingle(string SQLString, params SqlParameter[] cmdParms)
        {
            using (SqlConnection connection = new SqlConnection())
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    try
                    {
                        PrepareCommand(cmd, connection, null, SQLString, cmdParms);
                        object obj = cmd.ExecuteScalar();
                        cmd.Parameters.Clear();
                        if ((Object.Equals(obj, null)) || (Object.Equals(obj, System.DBNull.Value)))
                        {
                            return null;
                        }
                        else
                        {
                            return obj;
                        }
                    }
                    catch (System.Data.SqlClient.SqlException e)
                    {
                        throw e;
                    }
                }
            }
        }
        public static DataSet Query(string SQLString,params SqlParameter[]cmdParms)
        {
            using (SqlConnection connection = new SqlConnection())
            {
                SqlCommand cmd = new SqlCommand();
                PrepareCommand(cmd,connection,null,SQLString,cmdParms);
                using (SqlDataAdapter da = new SqlDataAdapter())
                {
                    DataSet ds = new DataSet();
                    try
                    {
                        da.Fill(ds, "ds");
                        cmd.Parameters.Clear();
                    }
                    catch (System.Data.SqlClient.SqlException e)
                    {
                        throw new Exception(e.Message);
                    }
                    return ds;
                }
            }
 
        }
        public static SqlDataReader ExecuteReader(string SQLString, params SqlParameter[] cmdParms)
        {
            SqlConnection connection = new SqlConnection();
            SqlCommand cmd = new SqlCommand();
            try
            {
                PrepareCommand(cmd, connection, null, SQLString, cmdParms);
                SqlDataReader myReader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                cmd.Parameters.Clear();
                return myReader;
            }
            catch (Exception e)
            {
                throw e;
            }
        }



        private static void PrepareCommand(SqlCommand cmd, SqlConnection conn, SqlTransaction trans, string cmdText, SqlParameter[] cmdParms)
        {
            if (conn.State != ConnectionState.Open)
                conn.Open();
            cmd.Connection = conn;
            cmd.CommandText = cmdText;
            if (trans != null)
                cmd.Transaction = trans;
            cmd.CommandType = CommandType.Text;
            if (cmdParms != null)
            {
                foreach (SqlParameter paremeter in cmdParms)
                {
                    if ((paremeter.Direction == ParameterDirection.InputOutput || paremeter.Direction == ParameterDirection.Input) && (paremeter.Value == null))
                    {
                        paremeter.Value =DBNull.Value;
                    }
                    cmd.Parameters.Add(paremeter);
                }
            }
        }
    }
}
